<script lang="ts">
	import { ButtonState, ButtonStatus, ButtonVariant } from '$lib/types/button';

	export let variant: ButtonVariant = ButtonVariant.STANDARD;
	export let status: ButtonStatus = ButtonStatus.STANDARD;
	export let state: ButtonState = ButtonState.ENABLED;

	let classes = 'variant-' + variant;
	classes += ' status-' + status;
	classes += ' state-' + state;
</script>

<div class="wrapper">
	<button class={classes}> <slot /></button>
</div>

<style lang="scss">
	.wrapper button {
		--color: #fff;
		--border-color: #000;
		--background-color: #000;
		appearance: none;
		font-size: inherit;
		border-radius: 4px;
		line-height: 1;
		padding: 0.5em 1em;
		cursor: pointer;
		color: var(--color);
		border: 1px solid var(--border-color);
		background-color: var(--background-color);
		transition-property: color, background-color, border-color, opacity;
		transition-duration: 100ms;
		transition-timing-function: ease-in-out;
	}

	/* variant-standard */
	.wrapper button.variant-standard {
		--color: #fff;
		--border-color: var(--color-shade-700);
		--background-color: var(--color-shade-700);
	}

	.wrapper button.variant-standard:hover,
	.wrapper button.variant-standard:focus,
	.wrapper button.variant-standard.status-active {
		--color: #fff;
		--border-color: var(--color-shade-800);
		--background-color: var(--color-shade-800);
	}

	/* variant-primary */
	.wrapper button.variant-primary {
		--color: var(--color-primary-900);
		--border-color: var(--color-primary-500);
		--background-color: var(--color-primary-500);
	}

	.wrapper button.variant-primary:hover,
	.wrapper button.variant-primary:focus,
	.wrapper button.variant-primary.status-active {
		--color: var(--color-primary-900);
		--border-color: var(--color-primary-500);
		--background-color: var(--color-primary-400);
	}

	/* variant-hyperlink */
	.wrapper button.variant-hyperlink {
		--color: var(--color-primary-500);
		--border-color: transparent;
		--background-color: transparent;
		position: relative;
	}

	.wrapper button.variant-hyperlink::after {
		content: ' ';
		position: absolute;
		width: 100%;
		height: 100%;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;
		border-radius: 4px;
		opacity: 0;
		background-color: var(--color-card-glass-bg);
		z-index: -1;
	}

	.wrapper button.variant-hyperlink:hover::after,
	.wrapper button.variant-hyperlink:focus::after,
	.wrapper button.variant-hyperlink.status-active::after {
		opacity: 1;
	}

	/* state-disabled */
	.wrapper button.state-disabled,
	.wrapper button.state-disabled:hover,
	.wrapper button.state-disabled:focus {
		opacity: 0.5;
		cursor: default;
	}
</style>
